package com.heyang;

import java.util.ArrayList;
import java.util.List;

public class Lexer {
	private List<Token> tokens;
	
	public Lexer(String mathExp) throws AnalyzerExp{
		String swallowed="";
		
		tokens=new ArrayList<Token>();
		for(int i=0;i<mathExp.length();i++){
            char c=mathExp.charAt(i);
            
            if(Character.isWhitespace(c)){
            	swallowed="";
            }else if(c=='+'){
            	addDigital2Tokens(swallowed);
            	swallowed="";
            	tokens.add(new Token(c,Token.TYPE_PLUS));
            }else if(c=='-'){
            	addDigital2Tokens(swallowed);
            	swallowed="";
            	tokens.add(new Token(c,Token.TYPE_MINUS));
            }else if(c=='*'){
            	addDigital2Tokens(swallowed);
            	swallowed="";
            	tokens.add(new Token(c,Token.TYPE_MULTI));
            }else if(c=='/'){
            	addDigital2Tokens(swallowed);
            	swallowed="";
            	tokens.add(new Token(c,Token.TYPE_DIVIDE));
            }else if(c=='('){
            	addDigital2Tokens(swallowed);
            	swallowed="";
            	tokens.add(new Token(c,Token.TYPE_LEFT_PAREN));
            }else if(c==')'){
            	addDigital2Tokens(swallowed);
            	swallowed="";
            	tokens.add(new Token(c,Token.TYPE_RIGHT_PAREN));
            }else {
            	swallowed+=c;
            }
		}
		
		if(swallowed.length()>0) {
			tokens.add(new Token(swallowed,Token.TYPE_DIGITAL));
			swallowed="";
		}
	}
	
	private void addDigital2Tokens(String text) throws AnalyzerExp{
		if(text.trim().length()>0) {
			tokens.add(new Token(text,Token.TYPE_DIGITAL));
		}
	}
	
	public List<Token> getTokens(){
		return tokens;
	}
	
	public static void main(String[] args) throws Exception{
		Lexer lexer=new Lexer("3+(2*5)");
		List<Token> tokens=lexer.getTokens();
		for(Token t:tokens) {
			System.out.print(t);
		}
	}
}
